/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gottamm.util;

import gottamm.entities.Music;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 *
 * @author tstrangi
 */
@MessageDriven(mappedName = "jms/scanMessages", activationConfig = {
    @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
    @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class ScanMessageBean implements MessageListener {

    public ScanMessageBean() {
    }

    public void onMessage(Message message) {
        System.out.println("ScanMessageBean");
        if (message instanceof TextMessage) {
            TextMessage tm = (TextMessage) message;
            ArrayList allMusic = null;
            try {
                String text = tm.getText();
                String pathMP3 = text;
                System.out.println("Received new message :" + text);
                //String pathMP3 = "C:\\Users\\tstrangi\\.netbeans\\6.9\\config\\GF3\\domain1\\music";
                //String pathMP3 = "D:\\music";
                System.out.println(pathMP3);
                allMusic = FileUtile.recursivelyAppliedFileForMP3(pathMP3);
                if (allMusic != null) {
                    if (!allMusic.isEmpty()) {
                        System.out.println("Taile du retour " + allMusic.size());
                        //for (int i = 0; i < allMusic.size(); i++) {
                        //    Music m = (Music) allMusic.get(i);
                        //    System.out.println("Titre=" + m.getTitle() + " de " + m.getArtist().getName());
                        //}
                    }
                }
            } catch (InvocationTargetException ex) {
                Logger.getLogger(ScanMessageBean.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IllegalAccessException ex) {
                Logger.getLogger(ScanMessageBean.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IllegalArgumentException ex) {
                Logger.getLogger(ScanMessageBean.class.getName()).log(Level.SEVERE, null, ex);
            } catch (SecurityException ex) {
                Logger.getLogger(ScanMessageBean.class.getName()).log(Level.SEVERE, null, ex);
            } catch (JMSException e) {
            } finally {
                System.out.println("End Traitement");
            }
        }
    }
}
